﻿#region Copyright
/* Copyright 2009 Oliver Sturm <oliver@sturmnet.org> All rights reserved. */
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ShowFilteredListBetter {
  public partial class Form1 : Form {
    public Form1( ) {
      InitializeComponent( );

      InitData();
    }

    List<Person> people;

    private void InitData( ) {
      people = new List<Person>{
        new Person { Name = "Anna" },
        new Person { Name = "Chris" },
        new Person { Name = "Willy" },
        new Person { Name = "Hugh" },
        new Person { Name = "Steve" },
        new Person { Name = "Betty" },
        new Person { Name = "Carla" },
        new Person { Name = "John" },
        new Person { Name = "Pete" },
        new Person { Name = "Susan" }
      };

      UpdateUI( );
    }

    private void UpdateUI( ) {
      DisplayListBox.DataSource = 
        GetFilteredList(GetFilterString( ));
    }

    string GetFilterString( ) {
      return String.IsNullOrEmpty(FilterTextBox.Text) ?
        null : FilterTextBox.Text;
    }

    private List<Person> GetFilteredList(string filter) {
      return filter == null ? people : 
        (from p in people
         where p.Name.Contains(filter)
         select p).ToList( );
    }

    private void FilterButton_Click(object sender, EventArgs e) {
      UpdateUI( );
    }
  }
}