#region Copyright
/* Copyright 2009 Oliver Sturm <oliver@sturmnet.org> All rights reserved. */
#endregion

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Diagnostics;
using System.Threading.Tasks;

namespace TreeWalker {
  public class Tree<T> {
    T value;
    public T Value {
      get { return value; }
    }

    Tree<T> left;
    public Tree<T> Left {
      get { return left; }
    }

    Tree<T> right;
    public Tree<T> Right {
      get { return right; }
    }

    private bool isEmpty;
    public bool IsEmpty {
      get { return isEmpty; }
    }

    public static readonly Tree<T> Empty = new Tree<T>( );

    private Tree( ) {
      isEmpty = true;
    }

    public Tree(T value, Tree<T> left, Tree<T> right) {
      this.value = value;
      this.left = left;
      this.right = right;
    }

    public Tree(T value) : this(value, Empty, Empty) { }
  }
}
